package com.rdlze.radializebase.interfaces;

import java.sql.SQLException;
import java.sql.Timestamp;
import java.text.ParseException;
import java.util.concurrent.ConcurrentLinkedQueue;

import com.rdlze.radializeutils.objects.MusicInfo;
import com.rdlze.radializeutils.objects.RadioStreamingMetadata;
import com.rdlze.radializeutils.objects.UpdateThreadBean;

public interface InterfaceCollector {

	public int returnRadioIdFromRadioList10(int radioIdList10)
			throws SQLException;

	public String returnArtistName(int artistId) throws SQLException;

	public abstract int checkArtist(String artistName) throws SQLException;

	public MusicInfo returnSongInfoFromList10(int songIdList10)
			throws SQLException;

	public abstract int checkSong(String songName, int artistId)
			throws SQLException;

	public abstract int checkMedia(String media, int artistId, int songId)
			throws SQLException;

	public abstract int insertArtist(String artistName,
			String artistMusicBrainzId) throws SQLException;

	public abstract int insertSong(int i, String s, String musicBrainzSongId)
			throws SQLException;

	public abstract int insertMedia(String name, int artistId, int songId,
			String musicBrainzArtistId, String musicBrainzSongId)
			throws Exception;

	public abstract void rejectMedia(UpdateThreadBean b) throws SQLException;

	// public abstract boolean checkPlayNow(int i, int j, int k) throws
	// SQLException;
	// public abstract boolean checkRadioPlayNow(int i) throws SQLException;
	// public abstract void updatePlayNow(int i, int j, int k, String s, String
	// s1)throws SQLException;
	// public abstract void insertPlayNow(int i, int j, int k, String s, String
	// s1) throws SQLException;

	public abstract void saveCollect(
			RadioStreamingMetadata radiostreamingmetadata) throws SQLException,
			ParseException;

	// public abstract void deletePlayNow(int idRadio) throws SQLException;
	public abstract boolean insertMediaFile(int songId, int mediaSource,
			int providerId, String name, String path) throws SQLException;

	public abstract boolean recommendSongForEvent(int songId, int eventId,
			int momentId, int userId, Timestamp timeToPlay) throws SQLException;

	public abstract boolean checkIfMediaFileHasBeenAlreadyInserted(int songId,
			int mediaSource, int providerId) throws SQLException;

	public abstract Integer[] insertSongAndMedia(int artistId, String songName,
			String musicBrainzSongId, String media, String musicBrainzArtistId,
			boolean production) throws SQLException;

	public abstract Integer[] insertArtistSongAndMedia(String artistName,
			String songName, String musicBrainzSongId, String mediaName,
			String artistIdMusicBrainz, boolean production) throws SQLException;

	public void saveCollect(ConcurrentLinkedQueue<RadioStreamingMetadata> rsms) throws SQLException, ClassNotFoundException;
}
