package com.rdlze.radializebase.interfaces;

import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;

import org.apache.lucene.queryparser.classic.ParseException;
import org.xml.sax.SAXException;

import com.rdlze.radializeutils.objects.BigTitleResp;
import com.rdlze.radializeutils.objects.MBResp;



public interface InterfaceMusicBrainzController {

	/**
	 * This method searches in music brainz server RMI using the bigTitle
	 * @param bigTitle 
	 * @param nGramSize 
	 * @param mbssi . The Music Brainz Interface RMI
	 * @param numResults
	 * @return
	 * @throws IOException
	 * @throws ParseException
	 * @see BigTitleResp
	 * 
	 */
	public BigTitleResp searchBigTitle(String bigTitle, int nGramSize,  int numResults, boolean shallContainResp) throws  IOException, ParseException;
	
	/**
	 * 
	 * @param bigTitle
	 * @param nGramSize
	 * @return
	 * @throws IOException
	 * @throws ParserConfigurationException
	 * @throws SAXException
	 * @throws InterruptedException
	 */
	
	public MBResp searchBigTitle(String bigTitle, int nGramSize) throws IOException, ParserConfigurationException, SAXException, InterruptedException;
	
	/**This Function searches in music brainz http server the artist and song

	 * @param artist The artist name to be search
	 * @param song The song name to be search
	 * @param proximitySearch Defines the algorithm to be used, if this value is true, It's acceptable not exactly words
	 * .if this value is false, searches by exactly word 
	 * @param limit The limit of results in music brainz query
	 * @param offset 
	 * @param hostMB  The music brainz host. Default www.radialize.com.br:5000
	 * @return
	 * @throws ParserConfigurationException
	 * @throws SAXException
	 * @throws IOException
	 * @throws InterruptedException
	 * @see MBResp
	 */
	public MBResp searchArtSong(String artist, String song, boolean proximitySearch, int limit, int offset, String hostMB) throws ParserConfigurationException, SAXException, IOException, InterruptedException;
	
	/***
	 * 
	 * @param artist
	 * @param song
	 * @param proximitySearch
	 * @param limit
	 * @param mbssi
	 * @return
	 * @throws ParseException
	 * @throws IOException
	 */
	public MBResp searchArtSong(String artist, String song, boolean proximitySearch, int limit) throws ParseException, IOException;
}
