package com.rdlze.radializebase.interfaces;

import java.io.Serializable;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.List;
import java.util.Map;

import com.rdlze.radializeutils.objects.ArtistIdAndTimestamp;
import com.rdlze.radializeutils.objects.Radio;
import com.rdlze.radializeutils.objects.RadioStreamingMetadata;


public interface InterfacePlayingNowServer extends Remote, Serializable
{	
	/**
	 * @return List of Radios playing the given artist
	 */
     public  List<Radio> artistPlayingNow(int artistID)throws RemoteException;
     
     /**
      * @return List of Radios playing the given song
      */
	 public  List<Radio> musicPlayingNow(int musicID)throws RemoteException;
	 
	 /**
      * Gets playing media of the given radio
      */
     public  RadioStreamingMetadata getRadioPlayNow(int radioId)throws RemoteException;
     
     /**
      * Gets map of artists playing at the moment
      */
     public  Map<Integer, ArtistIdAndTimestamp> getRadioArtistMap() throws RemoteException;
     
     /**
      * Gets map of songs playing at the moment
      */
     public  Map<Integer, Integer> getRadioSongMap() throws RemoteException;
     
     /**
      * Gets what is playing in a given radio
      */
     public  RadioStreamingMetadata getPlayingMedia(int radioId) throws RemoteException;
}
