package com.rdlze.radializebase.interfaces;

import java.io.Serializable;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.List;

import com.rdlze.radializeutils.objects.IndexResponse;
import com.rdlze.radializeutils.objects.SearchBean;

public interface InterfaceSearchServer extends Remote, Serializable
{
	
	/***
	 * This is the user search. You can search song, artist, genre or radio in database.
	 * @param bean. The bean contains the information about what will search. 
	 * There are two standard parameters, text and type.
	 * Text is the word will search, type is the kind of search{ 0 - All, 1 - Artist, 2 - Song, 3 - Genre, 4 - Radio}
	 * @return IndexResponse
	 * @throws RemoteException
	 * @see {@link SearchBean, IndexResponse}
	 */
	public IndexResponse search(SearchBean bean)throws RemoteException;
	
	
	
	/**
	 * This method get The auto complete set for user.
	 * @param text. Partial text to get auto complete, this text has to have the size bigger than 2
	 * @param quantity. The size of return.
	 * @return List<IndexResponse>
	 * @throws RemoteException 
	 * @see {@link IndexResponse}
	 */
	public List<IndexResponse> autocomplete(String text , int quantity)throws RemoteException;
}

