package com.rdlze.radializebase.interfaces;

import java.rmi.RemoteException;
import java.util.List;

import com.idealizeframework.irf.base.facade.RemoteFacade;
import com.rdlze.radializebase.utils.AIRecommendedItem;

/**
 * 
 * @author Alex Amorim Dutra
 * 
 */
public interface RemoteRadializeBatchFacade extends RemoteFacade {

	/**
	 * Process the recommendations request
	 * 
	 * @param input
	 *            String with input from client
	 * @return String with the recommendations
	 * @throws RemoteException
	 *             thrown when this object cannot be accessed remotely
	 */
	public String getRecommendations(String input) throws RemoteException;
	
	// search by artist
	// 1
	public List<AIRecommendedItem> searchByArtistReturnArtists(long userId,
			List<Integer> artistsIds, int howMany) throws RemoteException;

	// 2
	public List<AIRecommendedItem> searchByArtistReturnSongs(long userId,
			List<Integer> artistsIds, int howMany) throws RemoteException;

	// 3
	public List<AIRecommendedItem> searchByArtistReturnRadios(long userId,
			List<Integer> artistsIds, int howMany) throws RemoteException;

	// 4
	public List<AIRecommendedItem> searchByArtistReturnTags(long userId,
			List<Integer> artistsIds, int howMany) throws RemoteException;

	// search by song
	// 5
	public List<AIRecommendedItem> searchBySongReturnArtists(long userId,
			List<Integer> songsIds, int howMany) throws RemoteException;

	// 6
	public List<AIRecommendedItem> searchBySongReturnSongs(long userId,
			List<Integer> songsIds, int howMany) throws RemoteException;

	// 7
	public List<AIRecommendedItem> searchBySongReturnRadios(long userId,
			List<Integer> songsIds, int howMany) throws RemoteException;

	// 8
	public List<AIRecommendedItem> searchBySongReturnTags(long userId,
			List<Integer> songsIds, int howMany) throws RemoteException;

	// search by radio
	// 9
	public List<AIRecommendedItem> searchByRadioReturnArtists(long userId,
			List<Integer> radiosIds, int howMany) throws RemoteException;

	// 10
	public List<AIRecommendedItem> searchByRadioReturnSongs(long userId,
			List<Integer> radiosIds, int howMany) throws RemoteException;

	// 11
	public List<AIRecommendedItem> searchByRadioReturnRadios(long userId,
			List<Integer> radiosIds, int howMany) throws RemoteException;

	// 12
	public List<AIRecommendedItem> searchByRadioReturnTags(long userId,
			List<Integer> radiosIds, int howMany) throws RemoteException;

	// search by tag
	// 13
	public List<AIRecommendedItem> searchByTagReturnArtists(long userId,
			List<Integer> tagsIds, int howMany) throws RemoteException;

	// 14
	public List<AIRecommendedItem> searchByTagReturnSongs(long userId,
			List<Integer> tagsIds, int howMany) throws RemoteException;

	// 15
	public List<AIRecommendedItem> searchByTagReturnRadios(long userId,
			List<Integer> tagsIds, int howMany) throws RemoteException;

	// 16
	public List<AIRecommendedItem> searchByTagReturnTags(long userId,
			List<Integer> tagsIds, int howMany) throws RemoteException;

	// get recommendations
	// 17
	public List<AIRecommendedItem> getRecommendationsArtists(long userId,
			int howMany, List<Integer> momentsIds) throws RemoteException;

	// 18
	public List<AIRecommendedItem> getRecommendationsSongs(long userId,
			int howMany, List<Integer> momentsIds) throws RemoteException;

	// 19
	public List<AIRecommendedItem> getRecommendationsRadios(long userId,
			int howMany, List<Integer> momentsIds) throws RemoteException;

	// 20
	public List<AIRecommendedItem> getRecommendationsTags(long userId,
			int howMany, List<Integer> momentsIds) throws RemoteException;

	// 21
	public List<AIRecommendedItem> getRecommendationsFriends(long userId,
			int howMany, List<Integer> momentsIds) throws RemoteException;

}
