package com.rdlze.radializebase.utils;

public class AllFilters extends FilterBean {

	/**
	 * Default serial version
	 */
	private static final long serialVersionUID = 1L;

	private int useNovelty = 0;

	private int usePopularity = 0;

	public AllFilters() {

	}

	public AllFilters(int useNovelty) {
		this.useNovelty = useNovelty;
	}

	public AllFilters(int useNovelty, int usePopularity) {
		this.useNovelty = useNovelty;
		this.usePopularity = usePopularity;
	}

	/**
	 * Indica se devera ser retornado somente itens desconhecidos, itens
	 * conhecidos ou tanto faz. O valor -1 indica o retorno de itens conhecidos.
	 * O valor 1 indica o retorno de itens desconhecidos, isto se houver itens
	 * desconhecidos para completar a lista de recomendacao. O valor 0 tanto faz
	 * os itens de retorno serem conhecidos ou nao conhecidos.
	 * 
	 * @return inteiro indicando se deve ou nao retornar itens desconhecidos.
	 */
	public int getUseNovelty() {
		return useNovelty;
	}

	public void setUseNovelty(int useNovelty) {
		this.useNovelty = useNovelty;
	}

	/**
	 * Indica se devera ser retornado itens populares, itens raros ou tanto faz.
	 * O valor -1 indica o retorno de itens raros. O valor 1 indica o retorno de
	 * itens populares. O valor 0 e a lista de retorno original.
	 * 
	 * @return
	 */
	public int getUsePopularity() {
		return usePopularity;
	}

	public void setUsePopularity(int usePopularity) {
		this.usePopularity = usePopularity;
	}

	public String toString() {
		return "NOVIDADE: " + useNovelty + " POPULARIDADE: " + usePopularity;
	}
}
